package net.minecraft.block.state;

import java.util.List;
import javax.annotation.Nullable;
import net.minecraft.block.material.EnumPushReaction;
import net.minecraft.block.material.MapColor;
import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumBlockRenderType;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.Mirror;
import net.minecraft.util.Rotation;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public interface IBlockProperties {
   Material func_185904_a();

   boolean func_185913_b();

   boolean func_189884_a(Entity p_189884_1_);

   int func_185891_c();

   int func_185906_d();

   @SideOnly(Side.CLIENT)
   boolean func_185895_e();

   boolean func_185916_f();

   MapColor func_185909_g(IBlockAccess p_185909_1_, BlockPos p_185909_2_);

   IBlockState func_185907_a(Rotation p_185907_1_);

   IBlockState func_185902_a(Mirror p_185902_1_);

   boolean func_185917_h();

   @SideOnly(Side.CLIENT)
   boolean func_191057_i();

   EnumBlockRenderType func_185901_i();

   @SideOnly(Side.CLIENT)
   int func_185889_a(IBlockAccess p_185889_1_, BlockPos p_185889_2_);

   @SideOnly(Side.CLIENT)
   float func_185892_j();

   boolean func_185898_k();

   boolean func_185915_l();

   boolean func_185897_m();

   int func_185911_a(IBlockAccess p_185911_1_, BlockPos p_185911_2_, EnumFacing p_185911_3_);

   boolean func_185912_n();

   int func_185888_a(World p_185888_1_, BlockPos p_185888_2_);

   float func_185887_b(World p_185887_1_, BlockPos p_185887_2_);

   float func_185903_a(EntityPlayer p_185903_1_, World p_185903_2_, BlockPos p_185903_3_);

   int func_185893_b(IBlockAccess p_185893_1_, BlockPos p_185893_2_, EnumFacing p_185893_3_);

   EnumPushReaction func_185905_o();

   IBlockState func_185899_b(IBlockAccess p_185899_1_, BlockPos p_185899_2_);

   @SideOnly(Side.CLIENT)
   AxisAlignedBB func_185918_c(World p_185918_1_, BlockPos p_185918_2_);

   @SideOnly(Side.CLIENT)
   boolean func_185894_c(IBlockAccess p_185894_1_, BlockPos p_185894_2_, EnumFacing p_185894_3_);

   boolean func_185914_p();

   @Nullable
   AxisAlignedBB func_185890_d(IBlockAccess p_185890_1_, BlockPos p_185890_2_);

   void func_185908_a(World p_185908_1_, BlockPos p_185908_2_, AxisAlignedBB p_185908_3_, List<AxisAlignedBB> p_185908_4_, @Nullable Entity p_185908_5_, boolean p_185908_6_);

   AxisAlignedBB func_185900_c(IBlockAccess p_185900_1_, BlockPos p_185900_2_);

   RayTraceResult func_185910_a(World p_185910_1_, BlockPos p_185910_2_, Vec3d p_185910_3_, Vec3d p_185910_4_);

   boolean func_185896_q();

   Vec3d func_191059_e(IBlockAccess p_191059_1_, BlockPos p_191059_2_);

   boolean func_191058_s();

   BlockFaceShape func_193401_d(IBlockAccess p_193401_1_, BlockPos p_193401_2_, EnumFacing p_193401_3_);
}
